=== debian/changelog ===
clazy (1.4-4ubuntu2) disco; urgency=medium

  * Explicitly build using clang 7.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 30 Jan 2019 10:02:25 +0100

clazy (1.4-4) unstable; urgency=medium

  [ Lisandro Damián Nicanor Pérez Meyer ]
  * Fix typo in debian/rules.

  [ Pino Toscano ]
  * Ensure that clazy uses, and requires the same Clang used at build time:
    (Closes: #915390)
    - add a way to enforce a specific clang++ executable; patch
      select-clangpp.diff
    - specify the clang++ executable of the default Clang version
    - depend on the clang package providing the selected clang++ executable

 -- Pino Toscano <pino@debian.org>  Tue, 18 Dec 2018 21:58:07 +0100

clazy (1.4-3) unstable; urgency=medium

  * Backport upstream commit 9713a15f65424f06e45c78fc1bf1c2d2b27f4e36 to use 64
    as the limit in inefficient-qlist (fixing the test suite on 32bit Linux
    architectures); patch
    upstream_inefficient-qlist-Use-64-as-the-limit-instead-of-siz.patch.
  * Make sure to link with atomic on armel, both when building, and when
    linking the tests.

 -- Pino Toscano <pino@debian.org>  Sun, 02 Dec 2018 10:36:29 +0100

clazy (1.4-2) unstable; urgency=medium

  * Backport upstream commit 8ad500134416b960b3c28146e7245b7403f4c851 to
    properly install the clazy wrapper script as executable; patch
    upstream_Fix-installation-of-clazy-wrapper-scripts.patch.
  * Fix the execution of the test suite:
    - make the clazy wrapper script executable in the build directory, so it
      can be run
    - add the top-level build directory to $PATH, so that the clazy script
      is found
  * Fix Vcs-Git field to its non-redirecting version.
  * 'run-tests' autopkgtest: query clang/clang++ for their basic facts (like
    include/library paths, etc), so it is easier to debug test failures.

 -- Pino Toscano <pino@debian.org>  Tue, 27 Nov 2018 07:27:10 +0100

clazy (1.4-1) unstable; urgency=medium

  [ Scarlett Clark ]
  [ Pino Toscano ]
  * Initial release (Closes: #886883)

 -- Scarlett Clark <sgclark@kde.org>  Sun, 04 Nov 2018 22:03:44 +0100
