=== debian/control ===
Source: clazy
Section: devel
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Scarlett Clark <sgclark@kde.org>,
 Pino Toscano <pino@debian.org>
Build-Depends: chrpath,
               clang-7 (>= 1:3.9~),
               cmake (>= 3.3~),
               debhelper (>= 11~),
               libclang-7-dev (>= 1:3.9~),
               llvm-7-dev (>= 1:3.9~),
               python2,
               qtbase5-dev,
Standards-Version: 4.2.1
Homepage: https://www.kdab.com/clazy-video/
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/clazy.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/clazy

Package: clazy
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${clazy:clang}
Description: Clang plugin for additional warnings
 Clazy is a Clang plugin which extends the compiler with over
 50 warnings related to Qt best practices ranging from unneeded
 memory allocations to API misuse. It’s an opensource project
 spawned by KDAB’s R&D efforts for better C++ tooling.
