=== debian/tests/control ===
Tests: run-tests
Depends: @, clang-7, python2, qtbase5-dev
Restrictions: rw-build-tree, allow-stderr
