## clazy 1.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 # The man page is not available on Windows.
 #
 
-project(ClangLazy)
+project(clazy)
 
 cmake_minimum_required(VERSION 3.3)
 include(FeatureSummary)
@@ -14,7 +14,7 @@
 
 # Version setup
 set(CLAZY_VERSION_MAJOR "1")
-set(CLAZY_VERSION_MINOR "4")
+set(CLAZY_VERSION_MINOR "5")
 set(CLAZY_VERSION_PATCH "0")
 set(CLAZY_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}.${CLAZY_VERSION_PATCH}")
 set(CLAZY_PRINT_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}")
@@ -31,16 +31,12 @@
 add_definitions(-D__STDC_LIMIT_MACROS -D__STDC_CONSTANT_MACROS)
 add_definitions(-D_GNU_SOURCE -DHAVE_CLANG_CONFIG_H)
 
-option(CLAZY_BUILD_UTILS_LIB "Enable this option to build a library so you can reuse clazy's utility functions" OFF)
 option(CLAZY_AST_MATCHERS_CRASH_WORKAROUND "Disable AST Matchers if being built with clang. See bug #392223" ON)
+option(LINK_CLAZY_TO_LLVM "Links the clazy plugin to LLVM. Switch to OFF if your clang binary has all symbols already. Might need to be OFF if your LLVM is static." ON)
 
 if (CLAZY_AST_MATCHERS_CRASH_WORKAROUND AND "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
     message("Enabling AST Matchers workaround. Consider building with gcc instead. See bug #392223.")
     add_definitions(-DCLAZY_DISABLE_AST_MATCHERS)
-endif()
-
-if(CLAZY_BUILD_UTILS_LIB)
-  add_definitions(-DCLAZY_BUILD_UTILS_LIB)
 endif()
 
 if(NOT CLAZY_BUILD_WITH_CLANG AND MSVC AND NOT CLANG_LIBRARY_IMPORT)
@@ -128,60 +124,42 @@
     set_target_properties(${name} PROPERTIES LINK_FlAGS "-exported_symbols_list ${SYMBOL_FILE}")
   endif()
 
-  link_to_llvm(${name} FALSE)
+  if (LINK_CLAZY_TO_LLVM)
+    link_to_llvm(${name} FALSE)
+  endif()
 
   if(MSVC)
     target_link_libraries(${name} ${CLANG_LIBRARY_IMPORT}) # Link against clang.exe to share the plugin registry
   endif()
 
-  if(CLAZY_BUILD_UTILS_LIB)
-    target_link_libraries(${name} clazylib)
-  endif()
 endmacro()
 
-if(CLAZY_BUILD_UTILS_LIB)
-  # clazylib version
-  set(clazylib_VERSION_MAJOR 0)
-  set(clazylib_VERSION_MINOR 1)
-  # Enable the full x.y.z version only for release versions
-  set(clazylib_VERSION_PATCH 0)
-
-  set(clazylib_VERSION ${clazylib_VERSION_MAJOR}.${clazylib_VERSION_MINOR})
-  add_library(clazylib SHARED ${CLAZY_LIB_SRC})
-  link_to_llvm(clazylib FALSE)
-  generate_export_header(clazylib)
-  set_target_properties(clazylib PROPERTIES VERSION ${clazylib_VERSION} SOVERSION ${clazylib_VERSION_MAJOR})
-  install(TARGETS clazylib EXPORT LibClazyExport
+set(SYMBOL_FILE Lazy.exports)
+
+if (NOT CLAZY_BUILD_WITH_CLANG)
+  add_clang_plugin(ClazyPlugin ${CLAZY_PLUGIN_SRCS})
+  set_target_properties(ClazyPlugin PROPERTIES
+    LINKER_LANGUAGE CXX
+    PREFIX ""
+  )
+
+  install(TARGETS ClazyPlugin
     RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
     LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
     ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
   )
-endif()
-
-set(SYMBOL_FILE Lazy.exports)
-
-if (NOT CLAZY_BUILD_WITH_CLANG)
-  add_clang_plugin(ClangLazy ${CLAZY_PLUGIN_SRCS})
-  set_target_properties(ClangLazy PROPERTIES
-    LINKER_LANGUAGE CXX
-    PREFIX ""
-  )
-
-  install(TARGETS ClangLazy
-    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
-    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
-    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
-  )
 
   set(SHARE_INSTALL_DIR ${CMAKE_INSTALL_DATAROOTDIR} CACHE STRING "Share directory name")
 
   if(NOT WIN32)
+    file(RELATIVE_PATH BIN_RELATIVE_LIBDIR "${CMAKE_INSTALL_FULL_BINDIR}" "${CMAKE_INSTALL_FULL_LIBDIR}")
+    file(RELATIVE_PATH BIN_RELATIVE_SHAREDIR "${CMAKE_INSTALL_FULL_BINDIR}" "${CMAKE_INSTALL_FULL_DATAROOTDIR}")
     configure_file(${CMAKE_CURRENT_LIST_DIR}/clazy.cmake ${CMAKE_BINARY_DIR}/clazy @ONLY)
-    install(FILES ${CMAKE_BINARY_DIR}/clazy DESTINATION bin PERMISSIONS OWNER_WRITE OWNER_EXECUTE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_READ WORLD_EXECUTE)
+    install(PROGRAMS ${CMAKE_BINARY_DIR}/clazy DESTINATION bin)
   else()
-    install(FILES ${CMAKE_CURRENT_LIST_DIR}/clazy.bat DESTINATION bin PERMISSIONS OWNER_WRITE OWNER_EXECUTE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_READ WORLD_EXECUTE)
+    install(PROGRAMS ${CMAKE_CURRENT_LIST_DIR}/clazy.bat DESTINATION bin)
     if(MSVC)
-      install(FILES ${CMAKE_CURRENT_LIST_DIR}/clazy-cl.bat DESTINATION bin PERMISSIONS OWNER_WRITE OWNER_EXECUTE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_READ WORLD_EXECUTE)
+      install(PROGRAMS ${CMAKE_CURRENT_LIST_DIR}/clazy-cl.bat DESTINATION bin)
     endif()
   endif()
 
@@ -202,31 +180,6 @@
   # Build docs
   set(MAN_INSTALL_DIR "${SHARE_INSTALL_DIR}/man/man1")
   add_subdirectory(docs)
-
-  if(CLAZY_BUILD_UTILS_LIB)
-    # Install public headers
-    set(CLAZY_LIB_INCLUDES
-      src/AccessSpecifierManager.h
-      src/checkbase.h
-      src/checkmanager.h
-      src/clazy_export.h
-      src/clazy_stl.h
-      src/ContextUtils.h
-      src/FixItUtils.h
-      src/HierarchyUtils.h
-      src/LoopUtils.h
-      src/MacroUtils.h
-      src/QtUtils.h
-      src/SuppressionManager.h
-      src/StmtBodyRange.h
-      src/StringUtils.h
-      src/TemplateUtils.h
-      src/TypeUtils.h
-      src/Utils.h
-      src/ClazyContext.h
-      )
-    install(FILES ${CLAZY_LIB_INCLUDES} DESTINATION include/clazy)
-  endif()
 
   # rpath
   set(CMAKE_SKIP_BUILD_RPATH FALSE)
@@ -242,10 +195,10 @@
   add_executable(clazy-standalone ${CLAZY_STANDALONE_SRCS})
 
   if(MSVC)
-    # On MSVC clang-standalone crashes with a meaningless backtrace if linked to ClangLazy.dll
+    # On MSVC clang-standalone crashes with a meaningless backtrace if linked to ClazyPlugin.dll
     target_link_libraries(clazy-standalone clangFrontend)
   else()
-    target_link_libraries(clazy-standalone ClangLazy)
+    target_link_libraries(clazy-standalone ClazyPlugin)
   endif()
 
   link_to_llvm(clazy-standalone TRUE)
