=== debian/changelog ===
clazy (1.5-1ubuntu4) eoan; urgency=medium

  * Build with llvm/clang 8 (test errors with 9)..

 -- Matthias Klose <doko@ubuntu.com>  Thu, 22 Aug 2019 14:13:47 +0200

clazy (1.5-1ubuntu3) eoan; urgency=medium

  * Rebuild against new qt 5.12.2.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 05 Jun 2019 10:35:21 +0200

clazy (1.5-1ubuntu2) disco; urgency=medium

  * Drop Ubuntu delta. Allows build and tests to run with llvm/clang 8.

 -- Rik Mills <rikmills@kubuntu.org>  Tue, 19 Mar 2019 16:05:26 +0000

clazy (1.5-1ubuntu1) disco; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - Explicitly build using clang 7.

 -- Rik Mills <rikmills@kubuntu.org>  Thu, 21 Feb 2019 08:23:21 +0000

clazy (1.5-1) unstable; urgency=medium

  * New upstream release.
  * Update the patches:
    - upstream_Fix-clazy-list-not-listing-the-correct-doc-directory.patch:
      drop, backported from upstream
    - upstream_docs-add-empty-line-between-encoding-and-head1-NAME.patch: drop,
      backported from upstream
    - upstream_Fix-installation-of-clazy-wrapper-scripts.patch: drop,
      backported from upstream
    - upstream_inefficient-qlist-Use-64-as-the-limit-instead-of-siz.patch:
      drop, backported from upstream
    - debian-tests-link-atomic.diff: refresh
    - select-clangpp.diff: update to the new upstream version, and simplify
  * Update copyright.
  * Add qtdeclarative5-dev as build dependency, and as dependency for the
   'run-tests' autopkgtest, as it is needed by the test suite.
  * Update lintian overrides.
  + Bump Standards-Version to 4.3.0, no changes required.

 -- Pino Toscano <pino@debian.org>  Wed, 06 Feb 2019 22:26:46 +0100
