=== debian/control ===
--- 
+++ 
@@ -5,14 +5,15 @@
 Uploaders: Scarlett Clark <sgclark@kde.org>,
  Pino Toscano <pino@debian.org>
 Build-Depends: chrpath,
-               clang-7 (>= 1:3.9~),
+               clang-8 (>= 1:3.9~),
                cmake (>= 3.3~),
                debhelper (>= 11~),
-               libclang-7-dev (>= 1:3.9~),
-               llvm-7-dev (>= 1:3.9~),
+               libclang-8-dev (>= 1:3.9~),
+               llvm-8-dev (>= 1:3.9~),
                python2,
                qtbase5-dev,
-Standards-Version: 4.2.1
+               qtdeclarative5-dev,
+Standards-Version: 4.3.0
 Homepage: https://www.kdab.com/clazy-video/
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/clazy.git
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/clazy
