=== debian/rules ===
--- 
+++ 
@@ -13,9 +13,9 @@
 endif
 
 # keep the "++" at the end, to make sure the tool used is the C++ frontend
-CLANGPP=$(shell realpath $$(which clang++-7))++-7
-CLANGPP=/usr/bin/clang++-7
-LLVM_CONFIG=/usr/bin/llvm-config-7
+CLANGPP=$(shell realpath $$(which clang++-8))++-8
+CLANGPP=/usr/bin/clang++-8
+LLVM_CONFIG=/usr/bin/llvm-config-8
 
 %:
 	dh $@
