=== debian/tests/control ===
Tests: run-tests
Depends: @, clang-8, python2, qtbase5-dev, qtdeclarative5-dev
Restrictions: rw-build-tree, allow-stderr
