## clazy 1.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,21 +7,26 @@
 
 project(clazy)
 
-cmake_minimum_required(VERSION 3.3)
+cmake_minimum_required(VERSION 3.7)
+
+if (${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.12.0")
+    cmake_policy(SET CMP0074 NEW)
+endif()
+
 include(FeatureSummary)
 include(GenerateExportHeader)
 include("GNUInstallDirs")
 
 # Version setup
 set(CLAZY_VERSION_MAJOR "1")
-set(CLAZY_VERSION_MINOR "5")
+set(CLAZY_VERSION_MINOR "6")
 set(CLAZY_VERSION_PATCH "0")
 set(CLAZY_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}.${CLAZY_VERSION_PATCH}")
 set(CLAZY_PRINT_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}")
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_LIST_DIR}/cmake)
 if (NOT CLAZY_BUILD_WITH_CLANG)
-  find_package(Clang 3.9 MODULE REQUIRED)
+  find_package(Clang 5.0 MODULE REQUIRED)
 endif()
 
 set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
@@ -75,6 +80,12 @@
 include_directories(${CMAKE_BINARY_DIR})
 include_directories(${CLANG_INCLUDE_DIRS} ${CMAKE_CURRENT_LIST_DIR} ${CMAKE_CURRENT_LIST_DIR}/src)
 link_directories("${LLVM_INSTALL_PREFIX}/lib" ${LLVM_LIBRARY_DIRS})
+
+if (${LLVM_VERSION} VERSION_GREATER_EQUAL "9.0.0")
+    set(clang_tooling_refactoring_lib clangToolingRefactoring)
+else()
+    set(clang_tooling_refactoring_lib clangToolingRefactor)
+endif()
 
 macro(link_to_llvm name is_standalone)
   foreach(clang_lib ${CLANG_LIBS})
@@ -113,6 +124,9 @@
   if(WIN32)
     target_link_libraries(${name} version.lib)
   endif()
+    target_link_libraries(${name} clangTooling)
+    target_link_libraries(${name} clangToolingCore)
+    target_link_libraries(${name} ${clang_tooling_refactoring_lib})
 endmacro()
 
 macro(add_clang_plugin name)
@@ -137,7 +151,8 @@
 set(SYMBOL_FILE Lazy.exports)
 
 if (NOT CLAZY_BUILD_WITH_CLANG)
-  add_clang_plugin(ClazyPlugin ${CLAZY_PLUGIN_SRCS})
+  set(CLAZY_MINI_AST_DUMPER_SRCS src/MiniAstDumper.cpp)
+  add_clang_plugin(ClazyPlugin ${CLAZY_PLUGIN_SRCS} ${CLAZY_MINI_AST_DUMPER_SRCS})
   set_target_properties(ClazyPlugin PROPERTIES
     LINKER_LANGUAGE CXX
     PREFIX ""
@@ -171,7 +186,6 @@
   install(FILES ${README_LEVEL0_FILES} DESTINATION ${DOC_INSTALL_DIR}/level0)
   install(FILES ${README_LEVEL1_FILES} DESTINATION ${DOC_INSTALL_DIR}/level1)
   install(FILES ${README_LEVEL2_FILES} DESTINATION ${DOC_INSTALL_DIR}/level2)
-  install(FILES ${README_LEVEL3_FILES} DESTINATION ${DOC_INSTALL_DIR}/level3)
   install(FILES ${README_manuallevel_FILES} DESTINATION ${DOC_INSTALL_DIR}/manuallevel)
 
   # Install more doc files
@@ -217,6 +231,9 @@
     ${CLAZY_PLUGIN_SRCS}
 
     LINK_LIBS
+    clangToolingCore
+    clangToolingInclusions
+    ${clang_tooling_refactoring_lib}
     clangFrontend
     clangDriver
     clangCodeGen
@@ -245,3 +262,36 @@
 
   install(TARGETS clazy-standalone DESTINATION bin PERMISSIONS OWNER_WRITE OWNER_EXECUTE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_READ WORLD_EXECUTE)
 endif()
+
+function(to_raw_string_literal input_string output_string)
+    if (MSVC)
+        # Work around "C2026: string too big, trailing characters truncated"
+        #   https://docs.microsoft.com/en-us/cpp/error-messages/compiler-errors-1/compiler-error-c2026?view=vs-2019
+        # The limit is 16380 single-byte characters, so split up the string as
+        # suggested on the site.
+        set(str ${input_string})
+        set(chunk_size 1000)
+        set(result "\n")
+        string(LENGTH ${str} str_size)
+        while (${str_size} GREATER ${chunk_size})
+            string(SUBSTRING ${str} 0 ${chunk_size} chunk)
+            string(SUBSTRING ${str} ${chunk_size} -1 str)
+            set(chunk "R\"meta(${chunk})meta\"\n")
+            string(APPEND result ${chunk})
+            string(LENGTH ${str} str_size)
+        endwhile()
+        if (str_size GREATER 0)
+            string(APPEND result "R\"meta(${str})meta\"\n")
+        endif()
+        set(${output_string} ${result} PARENT_SCOPE)
+    else()
+        set(result "\nR\"meta(${input_string})meta\"\n")
+        set(${output_string} ${result} PARENT_SCOPE)
+    endif()
+endfunction()
+
+file(READ checks.json SUPPORTED_CHECKS_JSON_STR)
+to_raw_string_literal(${SUPPORTED_CHECKS_JSON_STR} SUPPORTED_CHECKS_JSON_STR)
+configure_file(checks.json.h.in checks.json.h)
+
+install(FILES org.kde.clazy.metainfo.xml DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/metainfo)
