=== debian/changelog ===
clazy (1.6-2ubuntu5) focal; urgency=medium

  * Explicitly build using LLVM 9.
  * Add /usr/lib/llvm-9/bin to PATH for running the autopkg tests.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 11 Mar 2020 08:58:12 +0100

clazy (1.6-2ubuntu3) focal; urgency=medium

  * Drop all the delta, it was concerning i386 sadness, but i386 is not the
    case anymore on focal.
  * No change rebuild against newer qt

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 12 Dec 2019 11:07:27 +0100

clazy (1.6-2) unstable; urgency=medium

  * Update copyright.
  * Bump the debhelper compatibility to 12:
    - switch the debhelper build dependency to debhelper-compat 12
    - remove debian/compat
  * Exclude the inefficient-qlist check on i386, as it currectly does not
    match the baseline (although it correctly detects the issue).

 -- Pino Toscano <pino@debian.org>  Sun, 20 Oct 2019 00:14:09 +0200

clazy (1.6-1) unstable; urgency=medium

  [ Lisandro Damián Nicanor Pérez Meyer ]
  * Switch python2 to python3 as build requirement. (Closes: #936308)

  [ Pino Toscano ]
  * New upstream release.
  * Update the patches:
    - debian-tests-link-atomic.diff: refresh
    - select-clangpp.diff: refresh
  * Update the build dependencies according to the upstream build system:
    - bump cmake to 3.7
    - bump clang, libclang-dev, and llvm-dev to 5.0
    - add clang-tools
  * Add the configuration for the CI on salsa.
  * Update the dependencies for the 'run-tests' autopkgtest:
    - replace python2 with python3 (see #936308)
    - add clang-tools
  * Bump Standards-Version to 4.4.1, no changes required.
  * Get the real clang++ compiler bypassing ccache.
  * Make sure to link with atomic (on architectures that need it) even if the
    compiler links in as-needed mode by default. (Closes: #939687)
  * Disable ccache when running the test suite, as clazy is documented to not
    work with it.

 -- Pino Toscano <pino@debian.org>  Fri, 18 Oct 2019 15:26:39 +0200
