=== debian/control ===
--- 
+++ 
@@ -5,15 +5,16 @@
 Uploaders: Scarlett Clark <sgclark@kde.org>,
  Pino Toscano <pino@debian.org>
 Build-Depends: chrpath,
-               clang-8 (>= 1:3.9~),
-               cmake (>= 3.3~),
-               debhelper (>= 11~),
-               libclang-8-dev (>= 1:3.9~),
-               llvm-8-dev (>= 1:3.9~),
-               python2,
+               clang-9 (>= 1:5.0~),
+               clang-tools-9 (>= 1:5.0~),
+               cmake (>= 3.7~),
+               debhelper-compat (= 12),
+               libclang-9-dev (>= 1:5.0~),
+               llvm-9-dev (>= 1:5.0~),
+               python3,
                qtbase5-dev,
                qtdeclarative5-dev,
-Standards-Version: 4.3.0
+Standards-Version: 4.4.1
 Homepage: https://www.kdab.com/clazy-video/
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/clazy.git
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/clazy
