=== debian/tests/control ===
Tests: run-tests
Depends: @, clang-9, clang-tools-9, python3, qtbase5-dev, qtdeclarative5-dev
Restrictions: rw-build-tree, allow-stderr
