## clazy 1.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,7 +19,7 @@
 
 # Version setup
 set(CLAZY_VERSION_MAJOR "1")
-set(CLAZY_VERSION_MINOR "6")
+set(CLAZY_VERSION_MINOR "7")
 set(CLAZY_VERSION_PATCH "0")
 set(CLAZY_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}.${CLAZY_VERSION_PATCH}")
 set(CLAZY_PRINT_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}")
@@ -38,6 +38,7 @@
 
 option(CLAZY_AST_MATCHERS_CRASH_WORKAROUND "Disable AST Matchers if being built with clang. See bug #392223" ON)
 option(LINK_CLAZY_TO_LLVM "Links the clazy plugin to LLVM. Switch to OFF if your clang binary has all symbols already. Might need to be OFF if your LLVM is static." ON)
+option(APPIMAGE_HACK "Links the clazy plugin to the clang tooling libs only. For some reason this is needed when building on our old CentOS 6.8 to create the AppImage." OFF)
 
 if (CLAZY_AST_MATCHERS_CRASH_WORKAROUND AND "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
     message("Enabling AST Matchers workaround. Consider building with gcc instead. See bug #392223.")
@@ -52,7 +53,7 @@
   # disable trigger-happy warnings from Clang/LLVM headers
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4267 /wd4244 /wd4291 /wd4800 /wd4141 /wd4146 /wd4251")
 elseif(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fno-common -Woverloaded-virtual -Wcast-qual -fno-strict-aliasing -pedantic -Wno-long-long -Wall -W -Wno-unused-parameter -Wwrite-strings -fno-exceptions -fno-rtti")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14 -fno-common -Woverloaded-virtual -Wcast-qual -fno-strict-aliasing -pedantic -Wno-long-long -Wall -W -Wno-unused-parameter -Wwrite-strings -fno-exceptions -fno-rtti")
 endif()
 
 set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,-flat_namespace -Wl,-undefined -Wl,suppress")
@@ -66,13 +67,12 @@
 message("Looking for std::regex support...")
 try_run(RUN_RESULT COMPILE_RESULT ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_LIST_DIR}/.cmake_has_regex_test.cpp)
 
-if(RUN_RESULT EQUAL 0)
-  set(HAS_STD_REGEX TRUE)
-else()
-  set(HAS_STD_REGEX FALSE)
-  add_definitions(-DNO_STD_REGEX)
-  message("old-style-connect check is disabled due to missing std::regex support")
-  message("Suppressions are disabled due to missing std::regex support")
+if(NOT RUN_RESULT EQUAL 0)
+  message("Using boost::regex instead of std::regex")
+  set(CLAZY_USES_BOOST_REGEX TRUE)
+  add_definitions(-DCLAZY_USES_BOOST_REGEX)
+  find_package(Boost REQUIRED COMPONENTS regex)
+  include_directories(${Boost_INCLUDE_DIRS})
 endif()
 
 include(ClazySources.cmake)
@@ -124,9 +124,17 @@
   if(WIN32)
     target_link_libraries(${name} version.lib)
   endif()
+  # clang >= 9.0 can provide a single shared library instead of split ones
+  if(CLANG_CLANG-CPP_LIB)
+    target_link_libraries(${name} clang-cpp)
+  else()
     target_link_libraries(${name} clangTooling)
     target_link_libraries(${name} clangToolingCore)
     target_link_libraries(${name} ${clang_tooling_refactoring_lib})
+  endif()
+  if (CLAZY_USES_BOOST_REGEX)
+    target_link_libraries(${name} ${Boost_LIBRARIES})
+  endif()
 endmacro()
 
 macro(add_clang_plugin name)
@@ -134,12 +142,24 @@
 
   add_library(${name} SHARED ${srcs})
 
+  if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.16.0")
+      # 30% speedup
+      target_precompile_headers(${name} PRIVATE src/checkbase.h)
+  endif()
+
   if(SYMBOL_FILE)
     set_target_properties(${name} PROPERTIES LINK_FlAGS "-exported_symbols_list ${SYMBOL_FILE}")
   endif()
 
   if (LINK_CLAZY_TO_LLVM)
     link_to_llvm(${name} FALSE)
+  else()
+    if (APPIMAGE_HACK)
+        # Hack to build on old CentOS 6.8
+        target_link_libraries(${name} clangTooling)
+        target_link_libraries(${name} clangToolingCore)
+        target_link_libraries(${name} ${clang_tooling_refactoring_lib})
+    endif()
   endif()
 
   if(MSVC)
@@ -167,6 +187,14 @@
   set(SHARE_INSTALL_DIR ${CMAKE_INSTALL_DATAROOTDIR} CACHE STRING "Share directory name")
 
   if(NOT WIN32)
+    if(APPLE)
+      find_program(READLINK_CMD greadlink)
+    else()
+      find_program(READLINK_CMD readlink)
+    endif()
+    if(NOT READLINK_CMD)
+      message(FATAL_ERROR "Could not find a proper readlink.  On Mac OSX you should install coreutils using homebrew in order to use the GNU readlink")
+    endif()
     file(RELATIVE_PATH BIN_RELATIVE_LIBDIR "${CMAKE_INSTALL_FULL_BINDIR}" "${CMAKE_INSTALL_FULL_LIBDIR}")
     file(RELATIVE_PATH BIN_RELATIVE_SHAREDIR "${CMAKE_INSTALL_FULL_BINDIR}" "${CMAKE_INSTALL_FULL_DATAROOTDIR}")
     configure_file(${CMAKE_CURRENT_LIST_DIR}/clazy.cmake ${CMAKE_BINARY_DIR}/clazy @ONLY)
@@ -294,4 +322,3 @@
 to_raw_string_literal(${SUPPORTED_CHECKS_JSON_STR} SUPPORTED_CHECKS_JSON_STR)
 configure_file(checks.json.h.in checks.json.h)
 
-install(FILES org.kde.clazy.metainfo.xml DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/metainfo)
