=== debian/changelog ===
clazy (1.7-2) unstable; urgency=medium

  * Exclude the inefficient-qlist check again, unfortunately on all the 32bit
    architectures: https://bugs.kde.org/423728.

 -- Pino Toscano <pino@debian.org>  Wed, 01 Jul 2020 10:44:27 +0200

clazy (1.7-1) unstable; urgency=medium

  [ Pino Toscano ]
  * New upstream release.
  * Update the patches:
    - select-clangpp.diff: refresh
  * Update lintian overrides.
  * Add Rules-Requires-Root: no.
  * Bump Standards-Version to 4.5.0, no changes required.
  * Run again the inefficient-qlist check on i386, as it was fixed upstream.
  * Change the python3 build dependency to python3:any, as Python is needed
    only as build tool.
  * Update copyright.

  [ Alexander Volkov ]
  * Don't install needless build dependencies when nocheck profile is enabled.

 -- Pino Toscano <pino@debian.org>  Wed, 01 Jul 2020 08:06:18 +0200
