=== debian/control ===
--- 
+++ 
@@ -5,16 +5,17 @@
 Uploaders: Scarlett Clark <sgclark@kde.org>,
  Pino Toscano <pino@debian.org>
 Build-Depends: chrpath,
-               clang-9 (>= 1:5.0~),
-               clang-tools-9 (>= 1:5.0~),
+               clang (>= 1:5.0~),
+               clang-tools (>= 1:5.0~),
                cmake (>= 3.7~),
                debhelper-compat (= 12),
-               libclang-9-dev (>= 1:5.0~),
-               llvm-9-dev (>= 1:5.0~),
-               python3,
-               qtbase5-dev,
-               qtdeclarative5-dev,
-Standards-Version: 4.4.1
+               libclang-dev (>= 1:5.0~),
+               llvm-dev (>= 1:5.0~),
+               python3:any <!nocheck>,
+               qtbase5-dev <!nocheck>,
+               qtdeclarative5-dev <!nocheck>,
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Homepage: https://www.kdab.com/clazy-video/
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/clazy.git
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/clazy
