=== debian/rules ===
--- 
+++ 
@@ -3,9 +3,6 @@
 include /usr/share/dpkg/architecture.mk
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-
-PATH := /usr/lib/llvm-9/bin:$(PATH)
-export PATH
 
 # LLVM 6.0 headers produce lots of class-memaccess warnings
 export DEB_CXXFLAGS_MAINT_APPEND = -Wno-class-memaccess
@@ -16,8 +13,8 @@
 endif
 
 # wrong size reported, although the test correctly identifies the issue
-# https://bugs.kde.org/show_bug.cgi?id=413169
-ifeq ($(DEB_HOST_ARCH),i386)
+# https://bugs.kde.org/show_bug.cgi?id=423728
+ifeq ($(DEB_HOST_ARCH_BITS),32)
 RUN_TESTS_ARGS += --exclude inefficient-qlist
 endif
