=== debian/tests/control ===
Tests: run-tests
Depends: @, clang, clang-tools, python3, qtbase5-dev, qtdeclarative5-dev
Restrictions: rw-build-tree, allow-stderr
